#ifndef	_STREAMS_H_
#define	_STREAMS_H_

#define	far_buffer(x)			((x)->buffer)
#define	far_bufsize(x)			((x)->bufsize)
#define	far_bufindex(x)			((x)->bufindex)
#define	far_buftype(x)			((x)->type)
#define	far_bufptr(x)			((char_t *)(((x)->buffer) + ((x)->bufindex)))
#define	far_setbuf(x, y, z)		(((x)->buffer) = y); (((x)->bufsize) = z)
#define	far_adv_index(x, y)		(((x)->bufindex) += (y))
#define	far_set_index(x, y)		(((x)->bufindex) = (y))
#define	far_set_size(x, y)		(((x)->bufsize) = (y))
#define	far_filedesc(x)			((x)->fd)
#define	far_setfiledesc(x, y)		(((x)->fd) = y)
#define	far_settype(x, y)		((x)->type = (y))
#define	_far_isbuffer(x)		((x)->type == _FAR_STREAM_BUF)
#define	_far_isfiledesc(x)		((x)->type == _FAR_STREAM_FD)
#define	_far_issockdesc(x)		((x)->type == _FAR_STREAM_SD)

#define	_FAR_STREAM_BUF		0x0
#define	_FAR_STREAM_FD		0x1
#define	_FAR_STREAM_SD		0x2

typedef	struct	_far_stream_
{
	int		fd;
	char_t		*buffer;
	char_t		__pad[3];
	uint64_t	bufindex;
	uint64_t	bufsize;
	int		type;
} buf_t;

ferr_t far_write(buf_t *, void *, uint64_t);
buf_t *far_bufalloc(uint64_t, int, int);
ferr_t far_read(buf_t *, void *, uint64_t, uint64_t *);
ferr_t far_bufseek(buf_t *, uint64_t);
ferr_t far_init_bufstream(buf_t **, char_t *, uint64_t);
ferr_t far_init_fdstream(buf_t **, int);
ferr_t far_init_sdstream(buf_t **, int);
ferr_t far_md5check_buf(buf_t *);
ferr_t far_md5check_fd(buf_t *);
uint64_t _far_bufpos(buf_t *);
ferr_t _far_bufseek(buf_t *, uint64_t);

#endif	/* _STREAMS_H_ */
