#include <string.h>

#include "far_types.h"
#include "far.h"
#include "bits.h"

uint64_t far_sw64bit(uint64_t n)
{
	uint64_t		result	= n;
#if __BYTE_ORDER == __BIG_ENDIAN
	register	char_t	tmp[8]	= { 0 };
	register	int	itmp	= 7;

	if(n)
	{
		memcpy(tmp, &n, 8);
		itmp = tmp[0];
		tmp[0] = tmp[7];
		tmp[7] = itmp;

		itmp = tmp[1];
		tmp[1] = tmp[6];
		tmp[6] = itmp;

		itmp = tmp[2];
		tmp[2] = tmp[5];
		tmp[5] = itmp;

		itmp = tmp[3];
		tmp[3] = tmp[4];
		tmp[4] = itmp;
		memcpy(&result, tmp, 8);
	}
#endif
	RETURN(result);
}

uint32_t far_sw32bit(uint32_t n)
{
	uint32_t		result	= n;
#if __BYTE_ORDER == __BIG_ENDIAN
	register	char_t	tmp[4]	= { 0 };
	register	int	itmp	= 7;

	if(n)
	{
		memcpy(tmp, &n, 4);
		itmp = tmp[0];
		tmp[0] = tmp[3];
		tmp[3] = itmp;

		itmp = tmp[1];
		tmp[1] = tmp[2];
		tmp[2] = itmp;
		memcpy(&result, tmp, 4);
	}
#endif
	RETURN(result);
}

ferr_t far_bconv_head(far_head_t *head)
{
	_far_returnvalue(result, _FAR_ERR_SUCCESS);

	if(head)
	{
		result = far_bconv_stat(&(head->d_info));

		if(_far_noerror(result))
		{
			head->d_offset = far_sw64bit(head->d_offset);
			head->d_pathsize = far_sw32bit(head->d_pathsize);
			head->d_lpathsize = far_sw32bit(head->d_lpathsize);
		}
	}
	else
	{
		_far_set_errcode(result, _FAR_ERR_INVAL);
	}

	return result;
}

ferr_t far_bconv_stat(far_stat_t *st)
{
	_far_returnvalue(result, _FAR_ERR_SUCCESS);

	if(st)
	{
		st->fst_uid = far_sw32bit(st->fst_uid);
		st->fst_gid = far_sw32bit(st->fst_gid);
		st->fst_mode = far_sw32bit(st->fst_mode);
		st->fst_atime = far_sw64bit(st->fst_atime);
		st->fst_mtime = far_sw64bit(st->fst_mtime);
		st->fst_rdev = far_sw64bit(st->fst_rdev);
		st->fst_size = far_sw64bit(st->fst_size);
	}
	else
	{
		_far_set_errcode(result, _FAR_ERR_INVAL);
	}

	return result;
}

